diff options
author | Klement Sekera <ksekera@cisco.com> | 2017-08-11 10:06:15 +0200 |
---|---|---|
committer | Dave Wallace <dwallacelf@gmail.com> | 2017-08-14 15:21:43 +0000 |
commit | db4e84cf2f8de0909c3483c8cadb25ac72fb3367 (patch) | |
tree | 4a53ac49f39e3c492088e417050b7c1d98760e88 /test/scripts/run_in_venv_with_cleanup.sh | |
parent | 3214dc382342573c242782849d98c23009960633 (diff) |
make test: properly handle ctrl-c
Change-Id: Iab88886ebc1582626813777ea45ce97fc8e36443
Signed-off-by: Klement Sekera <ksekera@cisco.com>
Diffstat (limited to 'test/scripts/run_in_venv_with_cleanup.sh')
-rwxr-xr-x | test/scripts/run_in_venv_with_cleanup.sh | 38 |
1 files changed, 38 insertions, 0 deletions
diff --git a/test/scripts/run_in_venv_with_cleanup.sh b/test/scripts/run_in_venv_with_cleanup.sh new file mode 100755 index 00000000000..541f584ac45 --- /dev/null +++ b/test/scripts/run_in_venv_with_cleanup.sh @@ -0,0 +1,38 @@ +#!/bin/bash + +rv=0 + +atexit() { + group_id=`ps -p $$ -o pgid=` + my_id=$$ + ids=`pgrep -g $group_id -d ' ' | sed "s/\b$my_id\b//g"` + echo "Killing possible remaining process IDs: $ids" + for id in $ids + do + if ps -p $id > /dev/null + then + kill -9 $id + fi + done + exit $rv +} + +trap "atexit;" SIGINT SIGTERM + +FORCE_FOREGROUND=$1 +shift + +source $1 +shift + +if [[ "${FORCE_FOREGROUND}" == "1" ]] +then + $* +else + $* & + wait +fi + +rv=$? +atexit +exit $rv |